"use strict";

var _react = _interopRequireDefault(require("react"));
var _enzyme = require("enzyme");
var _RootModal = _interopRequireDefault(require("../RootModal"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
describe('RootModal', function () {
  var _this = this;
  beforeEach(function () {
    jest.resetModules();
    _this.makeSubject = function () {
      return (0, _enzyme.mount)(_react["default"].createElement(_RootModal["default"], null, _react["default"].createElement("div", {
        className: "root"
      }, "foo")), {
        attachTo: document.body
      });
    };
  });
  it('should has a div.root tag', function () {
    var subject = _this.makeSubject();
    expect(subject.find('div.root').length).toBeTruthy();
  });
  it('should has parent element which has specific className', function () {
    var subject = _this.makeSubject();
    expect(subject.instance().modalTarget.classList[0]).toBe('intl-tel-input');
    expect(subject.instance().modalTarget.classList[1]).toBe('iti-container');
  });
  it('should has a modalTarget in body', function () {
    var subject = _this.makeSubject();
    subject.setState({
      foo: 'foo'
    });
    expect(subject.instance().modalTarget.classList[0]).toBe('intl-tel-input');
    expect(subject.instance().modalTarget.classList[1]).toBe('iti-container');
  });
  it('should not has a modalTarget in body', function () {
    var subject = _this.makeSubject();
    subject.unmount();
    expect(document.body.querySelector('.iti-container')).toBeNull();
  });
});